

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Essential api classes &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Exposing the API" href="../repository/repositories-intro.html" />
    <link rel="prev" title="The Shyft api" href="api-intro.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../../content/hydrology/getting_started.html#general-examples">General examples</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="api-intro.html">The Shyft <code class="docutils literal notranslate"><span class="pre">api</span></code></a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Essential <code class="docutils literal notranslate"><span class="pre">api</span></code> classes</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#Introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="#0.-Loading-required-python-modules-and-running-a-configured-shyft-simulation">0. Loading required python modules and running a configured shyft simulation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#1.-The-key-classes-within-the-api-and-being-“pythonic”">1. The key classes within the <code class="docutils literal notranslate"><span class="pre">api</span></code> and being “pythonic”</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#IntVector,-and-other----Vector-types"><code class="docutils literal notranslate"><span class="pre">IntVector</span></code>, and other <code class="docutils literal notranslate"><span class="pre">---Vector</span></code> types</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#1.-shyft.time_series.TimeSeries">1. <code class="docutils literal notranslate"><span class="pre">shyft.time_series.TimeSeries</span></code></a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../repository/repositories-intro.html">Exposing the API</a></li>
<li class="toctree-l3"><a class="reference internal" href="../shyft-intro-course-master/run_api_model.html">Constructing a model using the Shyft API</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#configured-simulation">Configured simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#advanced-tools">Advanced tools</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../content/hydrology/getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Essential <code class="docutils literal notranslate"><span class="pre">api</span></code> classes</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/api/api-essentials.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Essential-api-classes">
<h1>Essential <code class="docutils literal notranslate"><span class="pre">api</span></code> classes<a class="headerlink" href="#Essential-api-classes" title="Permalink to this headline">¶</a></h1>
<div class="section" id="Introduction">
<h2>Introduction<a class="headerlink" href="#Introduction" title="Permalink to this headline">¶</a></h2>
<p>There are a few features within the Shyft <code class="docutils literal notranslate"><span class="pre">api</span></code> that can be helpful for plotting, aggregating, and conducting data reduction. Herein we demonstrate some of this functionality. If you gain an understanding of the aspects described herein, working with Shyft becomes much simpler and more ‘pythonic’.</p>
</div>
<div class="section" id="0.-Loading-required-python-modules-and-running-a-configured-shyft-simulation">
<h2>0. Loading required python modules and running a configured shyft simulation<a class="headerlink" href="#0.-Loading-required-python-modules-and-running-a-configured-shyft-simulation" title="Permalink to this headline">¶</a></h2>
<p>The first step below is simply to get a simulation up and running using the features of <code class="docutils literal notranslate"><span class="pre">orchestration</span></code>. If you are not familiar with this step, it is recommended to see the <a class="reference internal" href="../nea-example/simulation-configured.html"><span class="doc">configured simulation</span></a> example first.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Pure python modules and jupyter notebook functionality</span>
<span class="c1"># first you should import the third-party python modules which you&#39;ll use later on</span>
<span class="c1"># the first line enables that figures are shown inline, directly in the notebook</span>
<span class="o">%</span><span class="k">pylab</span> inline
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">datetime</span> <span class="k">as</span> <span class="nn">dt</span>
<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">path</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Populating the interactive namespace from numpy and matplotlib
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># try to auto-configure the path, -will work in all cases where doc and data</span>
<span class="c1"># are checked out at same level</span>
<span class="n">shyft_data_path</span> <span class="o">=</span> <span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;../../../shyft-data&quot;</span><span class="p">)</span>
<span class="k">if</span> <span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">shyft_data_path</span><span class="p">)</span> <span class="ow">and</span> <span class="s1">&#39;SHYFT_DATA&#39;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">[</span><span class="s1">&#39;SHYFT_DATA&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">shyft_data_path</span>

</pre></div>
</div>
</div>
</div>
<div class="section" id="1.-The-key-classes-within-the-api-and-being-“pythonic”">
<h2>1. The key classes within the <code class="docutils literal notranslate"><span class="pre">api</span></code> and being “pythonic”<a class="headerlink" href="#1.-The-key-classes-within-the-api-and-being-“pythonic”" title="Permalink to this headline">¶</a></h2>
<p>There are several essential class types that are used throughout Shyft, and initially, these may cause some challenges – particularly to seasoned python users. If you are used to working with the <code class="docutils literal notranslate"><span class="pre">datetime</span></code> module, <code class="docutils literal notranslate"><span class="pre">pandas</span></code> and <code class="docutils literal notranslate"><span class="pre">numpy</span></code>, it will be important that you understand some of the basic concepts presented here.</p>
<p>At first, some of this may seem unneccessary. The point of these specialized classes are to provide efficiency withing the C++ core, and with respect to time, to make sure the calculations adhere to a few strict concepts.</p>
<div class="section" id="IntVector,-and-other----Vector-types">
<h3><code class="docutils literal notranslate"><span class="pre">IntVector</span></code>, and other <code class="docutils literal notranslate"><span class="pre">---Vector</span></code> types<a class="headerlink" href="#IntVector,-and-other----Vector-types" title="Permalink to this headline">¶</a></h3>
<p>When you see the class <code class="docutils literal notranslate"><span class="pre">IntVector</span></code>, just recognize these as lists. They should behave nearly identical to python lists, and where possible, we treat them as such. The main difference, is that they are specialized for their ‘type’, and under the covers within Shyft provide great efficiency.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">IntVector</span><span class="p">,</span> <span class="n">DoubleVector</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="c1"># works:</span>
<span class="n">iv</span> <span class="o">=</span> <span class="n">IntVector</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="mi">5</span><span class="p">])</span>
<span class="nb">print</span><span class="p">(</span><span class="n">iv</span><span class="p">)</span>
<span class="c1"># won&#39;t work:</span>
<span class="c1"># iv[2] = 2.2</span>

<span class="c1"># see the DoubleVector</span>
<span class="n">dv</span> <span class="o">=</span> <span class="n">DoubleVector</span><span class="p">([</span><span class="mf">1.0</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mf">4.5</span><span class="p">,</span> <span class="mf">10.110293</span><span class="p">])</span>
<span class="nb">print</span><span class="p">(</span><span class="n">dv</span><span class="p">)</span>
<span class="n">dv</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="mf">2.3</span>

</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[0 1 4 5]
[ 1.        3.        4.5      10.110293]
</pre></div></div>
</div>
<p>Note, however, that these containers are very basic lists. They don’t have methods such as <code class="docutils literal notranslate"><span class="pre">.pop</span></code> and <code class="docutils literal notranslate"><span class="pre">.index</span></code>. In generally, they are meant just to be used as first class containers for which you’ll pass data into before passing it to Shyft. For those familiar with python and numpy, you can think of it similar to the advantages of using numpy arrays over pure python lists. The numpy array is far more efficient. In the case of Shyft, it is similar, and the <code class="docutils literal notranslate"><span class="pre">IntVector</span></code>, <code class="docutils literal notranslate"><span class="pre">DoubleVector</span></code> and
other specialized vector types are much more efficient.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">IV1</span> <span class="o">=</span> <span class="n">IntVector</span><span class="p">([</span><span class="nb">int</span><span class="p">(</span><span class="n">i</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="mi">1000</span><span class="p">)])</span>

</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># once the shyft_path is set correctly, you should be able to import shyft modules</span>
<span class="kn">import</span> <span class="nn">shyft</span>

<span class="c1"># if you have problems here, it may be related to having your LD_LIBRARY_PATH</span>
<span class="c1"># pointing to the appropriate libboost_python libraries (.so files)</span>
<span class="kn">from</span> <span class="nn">shyft</span> <span class="kn">import</span> <span class="n">hydrology</span>
<span class="kn">from</span> <span class="nn">shyft.hydrology.repository.default_state_repository</span> <span class="kn">import</span> <span class="n">DefaultStateRepository</span>
<span class="kn">from</span> <span class="nn">shyft.hydrology.orchestration.configuration.yaml_configs</span> <span class="kn">import</span> <span class="n">YAMLSimConfig</span>
<span class="kn">from</span> <span class="nn">shyft.hydrology.orchestration.simulators.config_simulator</span> <span class="kn">import</span> <span class="n">ConfigSimulator</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># here is the *.yaml file that configures the simulation:</span>
<span class="n">config_file_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;../nea-example/nea-config/neanidelva_simulation.yaml&quot;</span><span class="p">)</span>
<span class="n">cfg</span> <span class="o">=</span> <span class="n">YAMLSimConfig</span><span class="p">(</span><span class="n">config_file_path</span><span class="p">,</span> <span class="s2">&quot;neanidelva&quot;</span><span class="p">)</span>

<span class="n">simulator</span> <span class="o">=</span> <span class="n">ConfigSimulator</span><span class="p">(</span><span class="n">cfg</span><span class="p">)</span>
<span class="c1"># run the model, and we&#39;ll just pull the `api.model` from the `simulator`</span>
<span class="n">simulator</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
<span class="n">model</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Running simulation...
</pre></div></div>
</div>
</div>
</div>
<div class="section" id="1.-shyft.time_series.TimeSeries">
<h2>1. <code class="docutils literal notranslate"><span class="pre">shyft.time_series.TimeSeries</span></code><a class="headerlink" href="#1.-shyft.time_series.TimeSeries" title="Permalink to this headline">¶</a></h2>
<p>The Shyft time_series, <code class="docutils literal notranslate"><span class="pre">shyft.time_series</span></code> contains a lot of functionality worth exploring.</p>
<p>The <code class="docutils literal notranslate"><span class="pre">TimeSeries</span></code> class provides some tools for adding timeseries, looking at statistics, etc. Below is a quick exploration of some of the possibilities. Users should explore using the source code, tab completion, and most of all <code class="docutils literal notranslate"><span class="pre">help</span></code> to get the full story…</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># First, we can also plot the statistical distribution of the</span>
<span class="c1"># discharges over the sub-catchments</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">TsVector</span><span class="p">,</span><span class="n">IntVector</span><span class="p">,</span><span class="n">TimeAxis</span><span class="p">,</span><span class="n">Calendar</span><span class="p">,</span><span class="n">time</span><span class="p">,</span><span class="n">UtcPeriod</span>
<span class="c1"># api.TsVector() is a a strongly typed list of time-series,that supports time-series vector operations.</span>
<span class="n">discharge_ts</span> <span class="o">=</span> <span class="n">TsVector</span><span class="p">()</span> <span class="c1">#  except from the type, it just works as a list()</span>
<span class="c1"># loop over each catchment, and extract the time-series (we keep them as such for now)</span>
<span class="k">for</span> <span class="n">cid</span> <span class="ow">in</span> <span class="n">model</span><span class="o">.</span><span class="n">catchment_ids</span><span class="p">:</span> <span class="c1"># fill in discharge time series for all subcatchments</span>
    <span class="n">discharge_ts</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">([</span><span class="nb">int</span><span class="p">(</span><span class="n">cid</span><span class="p">)]))</span>

<span class="c1"># get the percentiles we want, note -1 = arithmetic average</span>
<span class="n">percentiles</span><span class="o">=</span> <span class="n">IntVector</span><span class="p">([</span><span class="mi">10</span><span class="p">,</span><span class="mi">25</span><span class="p">,</span><span class="mi">50</span><span class="p">,</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="mi">75</span><span class="p">,</span><span class="mi">90</span><span class="p">])</span>

<span class="c1"># create a Daily(for the fun of it!) time-axis for the percentile calculations</span>
<span class="c1"># (our simulation could be hourly)</span>
<span class="n">ta_statistics</span> <span class="o">=</span> <span class="n">TimeAxis</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">0</span><span class="p">),</span> <span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">,</span> <span class="mi">365</span><span class="p">)</span>

<span class="c1"># then simply get out a new set of time-series, corresponding to the percentiles we specified</span>
<span class="c1"># note that discharge_ts is of the TsVector type, not a simple list as in our first example above</span>
<span class="n">discharge_percentiles</span> <span class="o">=</span> <span class="n">discharge_ts</span><span class="o">.</span><span class="n">percentiles</span><span class="p">(</span><span class="n">ta_statistics</span><span class="p">,</span> <span class="n">percentiles</span><span class="p">)</span>

<span class="c1">#utilize that we know that all the percentile time-series share a common time-axis</span>
<span class="n">ts_timestamps</span> <span class="o">=</span> <span class="p">[</span><span class="n">dt</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">start</span><span class="p">))</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">ta_statistics</span><span class="p">]</span>

<span class="c1"># Then we can make another plot of the percentile data for the sub-catchments</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">20</span><span class="p">,</span><span class="mi">15</span><span class="p">))</span>

<span class="c1"># plot each discharge percentile in the discharge_percentiles</span>
<span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">ts_percentile</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">discharge_percentiles</span><span class="p">):</span>
    <span class="n">clr</span><span class="o">=</span><span class="s1">&#39;k&#39;</span>
    <span class="k">if</span> <span class="n">percentiles</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;=</span> <span class="mf">0.0</span><span class="p">:</span>
        <span class="n">clr</span><span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="nb">float</span><span class="p">(</span><span class="n">percentiles</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">/</span><span class="mf">100.0</span><span class="p">))</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">ts_percentile</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">percentiles</span><span class="p">[</span><span class="n">i</span><span class="p">]),</span> <span class="n">color</span><span class="o">=</span><span class="n">clr</span><span class="p">)</span>

<span class="c1"># also plot catchment discharge along with the statistics</span>
<span class="c1"># notice that we use .average(ta_statistics) to properly align true-average values to time-axis</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">discharge_ts</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">average</span><span class="p">(</span><span class="n">ta_statistics</span><span class="p">)</span><span class="o">.</span><span class="n">values</span><span class="p">,</span>
        <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;CID </span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">catchment_ids</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span>
        <span class="n">linewidth</span><span class="o">=</span><span class="mf">2.0</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.7</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;b&#39;</span><span class="p">)</span>

<span class="n">fig</span><span class="o">.</span><span class="n">autofmt_xdate</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s2">&quot;Percentiles&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;discharge [m3 s-1]&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;discharge [m3 s-1]&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_api_api-essentials_11_1.png" src="../../_images/notebooks_api_api-essentials_11_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># a simple percentile plot, from orchestration looks nicer</span>
<span class="kn">from</span> <span class="nn">shyft.hydrology.orchestration</span> <span class="kn">import</span> <span class="n">plotting</span> <span class="k">as</span> <span class="n">splt</span>
<span class="n">oslo</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">(</span><span class="s1">&#39;Europe/Oslo&#39;</span><span class="p">)</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">16</span><span class="p">,</span><span class="mi">8</span><span class="p">))</span>
<span class="n">splt</span><span class="o">.</span><span class="n">set_calendar_formatter</span><span class="p">(</span><span class="n">oslo</span><span class="p">)</span>
<span class="n">h</span><span class="p">,</span> <span class="n">ph</span> <span class="o">=</span> <span class="n">splt</span><span class="o">.</span><span class="n">plot_np_percentiles</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,[</span> <span class="n">p</span><span class="o">.</span><span class="n">values</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">discharge_percentiles</span><span class="p">],</span>
                                <span class="n">base_color</span><span class="o">=</span><span class="p">(</span><span class="mf">0.03</span><span class="p">,</span><span class="mf">0.01</span><span class="p">,</span><span class="mf">0.3</span><span class="p">))</span>

<span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;discharge [m3 s-1]&quot;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s2">&quot;CID </span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">catchment_ids</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0.5, 1.0, &#39;CID 1996&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_api_api-essentials_12_1.png" src="../../_images/notebooks_api_api-essentials_12_1.png" />
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span>
</pre></div>
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../repository/repositories-intro.html" class="btn btn-neutral float-right" title="Exposing the API" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="api-intro.html" class="btn btn-neutral float-left" title="The Shyft api" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>